#define MAIN 1

#include "include.h"
/*
void main()
{
	MiscAnalogRegs.IOMUX.all = 0; //enable JTAG
	start_state =5;
	//Check to see if the last DFLASH erase was interrupted
	look_for_interrupted_dflash_erase();

	restore_default_all();



	period = (SWITCH_FREQ_NUMERATOR / pmbus_dcdc_config[0].switching_frequency); // in 4 ns


	configure_cpcc();

//	init_uart0();
	init_uart1();

	init_gpio();

	init_pmbus();

	init_dpwm();

	init_adc12();
	
	init_protection();

	init_voltage_loop();

	init_current_loop();

	init_light_load_configuration();

	init_miscellaneous();

	init_timer_interrupt();

	for(;;)
	{
//		pmbus_handler();

//		uart_transmit_data();

//		pmbus_handler();

//		uart_process_rx_data();

//		pmbus_handler();

		if (erase_segment_counter > 0)
		{
			erase_task();	//  Handle the DFlash segment erases
        }
		
		decimal_out_5_digits(supply_state);
		char_out('\r');
		char_out('\n');
	}
}

#pragma INTERRUPT(c_int00,RESET)
void c_int00(void)
{
	main();
}

*/



#define PERIOD         (40000) // 4 Ghz high speed clock/100 KHz switching frequency = 40000.

int ram_event2; 
// comment for hyperknob [min=2500, max=37500, step=2500]
int ram_event1;
// comment for hyperknob [min=2500, max=37500, step=2500]

void init_dpwm2(void) 
{
	
    Dpwm2Regs.DPWMCTRL0.bit.PWM_EN = 0;     //disable locally for init
	Dpwm2Regs.DPWMCTRL0.bit.CLA_EN = 0;		//default is 1 - use cla

	Dpwm2Regs.DPWMPRD.all = PERIOD;         //use .all for all values, make sure scaling matches.
	Dpwm2Regs.DPWMEV1.all = 0;              //Put event 1 at start of period
	Dpwm2Regs.DPWMEV2.all = PERIOD/2-4000;       //1/4 of period - divide is OK because it's all constants.
	Dpwm2Regs.DPWMEV3.all = PERIOD/2;       //1/2 of period   
	Dpwm2Regs.DPWMEV4.all = (PERIOD * 4)/4-4000; //3/4 of period

    Dpwm2Regs.DPWMCTRL0.bit.PWM_EN = 1;     //enable locally
	LoopMuxRegs.GLBEN.bit.DPWM2_EN = 1;     //enable globally
}


void init_dpwm3(void) 
{
	
    Dpwm3Regs.DPWMCTRL0.bit.PWM_EN = 0;     //disable locally for init
	Dpwm3Regs.DPWMCTRL0.bit.CLA_EN = 0;		//default is 1 - use cla

	Dpwm3Regs.DPWMPRD.all = PERIOD;         //use .all for all values, make sure scaling matches.
	Dpwm3Regs.DPWMEV1.all = 0+16000+2000;              //Put event 1 at start of period
	Dpwm3Regs.DPWMEV2.all = PERIOD/2+16000-2000;       //1/4 of period - divide is OK because it's all constants.
	Dpwm3Regs.DPWMEV3.all = PERIOD/2+16000;       //1/2 of period   
	Dpwm3Regs.DPWMEV4.all = 14000; //3/4 of period

    Dpwm3Regs.DPWMCTRL0.bit.PWM_EN = 1;     //enable locally
	LoopMuxRegs.GLBEN.bit.DPWM3_EN = 1;     //enable globally
}


void main()
{
	if(GioRegs.FAULTIN.bit.TMS_IN == 0) //emergency backdoor - TMS is normally pulled up by external resistor
	{
		clear_integrity_word();  //if it's pulled down, clear checksum (integrity word)
	}

	init_pmbus();
	init_dpwm2();
	init_dpwm3();
	ram_event2 = Dpwm2Regs.DPWMEV2.all; //initialize hyperknob
	ram_event1 = Dpwm3Regs.DPWMEV2.all; //initialize hyperknob
	for(;;)
	{
		pmbus_handler();
		Dpwm2Regs.DPWMEV2.all = ram_event2; //put hyperknob value into register
		Dpwm3Regs.DPWMEV2.all = ram_event1; //put hyperknob value into register
	}
}

#pragma INTERRUPT(c_int00,RESET)

void c_int00(void)
{
	main();
}
